-----------{fastreverse}----------

--reverse "dummy"
rev [] = []
rev (h:t) = rev t ++[h]

--resultado fornecido pelo MAG
reverseMAG = foldr (\c d e -> d (c:e))(\f->f)

--codificao aps o resultado fornecido pelo MAG
fastreverse [] e = e
fastreverse (c:d) e = fastreverse d (c:e)


----------{fastsumsq}-------------
square x = x*x

--sumsq "dummy"
sumsq = sum. map square


--fastsumsq fornecido pelo MAG
sumsqMAG = foldr(\b -> (+) (square b))  0

--codificao do fastsumsq

fastsumsq [] = 0
fastsumsq (h:t) = square h + fastsumsq t


------------{fastmindepth}------------------------
data Tree a = Leaf a | Bin (Tree a) (Tree a)
        deriving Show

--codificao do mindepth "dummy"
mindepth (Leaf x) = 0
mindepth (Bin t1 t2) = min (mindepth t1)(mindepth t2) + 1

--fold para Tree
foldtree l b (Leaf a) = l a
foldtree l b (Bin t1 t2) = b (foldtree l b t1)(foldtree l b t2)


--resultado apresentado pelo MAG
mindepthMAG = foldtree (\ d -> min) (\ g h i ->
                                     (\ j -> if (i+1) >= j then j 
				             else g (i+1) (h (i+1) j))                                      
                                     )


--codificao do mindepth pelo resultado 
--fornecido pelo MAG
fastmindepth (Leaf x) act mi = min act mi
fastmindepth (Bin t1 t2) act mi = 
              if ((act+1)>= mi) then mi
              else fastmindepth t1 (1+act) (fastmindepth t2 (1+act) mi)



t1= Bin (Bin (Bin (Leaf 1)(Leaf 2)) (Bin (Leaf 3)(Leaf 4))) (Leaf 5)

t2= Leaf 1
