{- postorder.p -}

data Rose a = Node a [Rose a];

postorder (Node a ts) = concat (map postorder ts) ++ [a];

map f [] = [];
map f (x:xs) = f x:map f xs;

concat [] = [];
concat (x:xs) = x++concat xs;

TRANSFORM fastpost
REDEFINE postorder t = fastpost t []
SPECIFYING fastpost t xs = postorder (foldrose Node (:) [] t) ++ xs
USING 
      DEFINITION postorder,(++),map,concat;

      catassoc: (xs ++ ys) ++ zs = xs ++ (ys ++ zs);
  
      promotion: f (foldrose n step e t) = foldrose n' step' e' t,
            if { g e = e';
                 \x y -> g (step x y) = \x y -> step' (f x) (g y);
                 \x y -> f (n x y) = \x y -> n' x (g y) }
END;

foldrose f step e (Node a ts) = f a (foldr (step . foldrose f step e) e ts);

foldr f e [] = e;
foldr f e (x:xs) = f x (foldr f e xs);
